package ch.dlcm.controller.access;

import static org.springframework.hateoas.mvc.ControllerLinkBuilder.linkTo;
import static org.springframework.hateoas.mvc.ControllerLinkBuilder.methodOn;

import org.springframework.hateoas.mvc.ControllerLinkBuilder;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import ch.dlcm.controller.AssociationController;
import ch.dlcm.model.Order;
import ch.dlcm.model.oais.ArchivalInfoPackage;
import ch.dlcm.rest.RESTAction;
import ch.dlcm.rest.RESTName;
import ch.dlcm.rest.RESTTool;

@RestController
@RequestMapping("/" + RESTName.ACCESS + "/" + RESTName.ORDER + "/{parentid}/" + RESTName.AIP)
public class OrderAipController extends AssociationController<Order, ArchivalInfoPackage> {

  @Override
  protected Class<ArchivalInfoPackage> getSubResourceClass() {
    return ArchivalInfoPackage.class;
  }

  @Override
  protected Class<Order> getMainResourceClass() {
    return Order.class;
  }
  
  @Override
  protected boolean addLinks(String parentid, ArchivalInfoPackage aip) {
    aip.removeLinks();
    ControllerLinkBuilder clb = linkTo(methodOn(this.getClass()).listAll(parentid, null));
    aip.add(clb.slash(aip.getDlcmId()).withSelfRel());
    aip.add((RESTTool.referenceLink(clb.slash(aip.getDlcmId()).toUriComponentsBuilder(),RESTName.ACCESS)).withSelfRel());
    aip.add(clb.withRel(RESTAction.LIST));
    aip.add((RESTTool.parentLink(clb.toUriComponentsBuilder())).withRel(RESTAction.PARENT));
    return true;
  }
}
