package ch.dlcm.controller;

import javax.annotation.PostConstruct;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import ch.dlcm.repository.FundingAgencyRepository;
import ch.dlcm.repository.InstitutionRepository;
import ch.dlcm.repository.LanguageRepository;
import ch.dlcm.repository.LicenseRepository;
import ch.dlcm.repository.RoleRepository;
import ch.dlcm.rest.RESTName;

@RestController
@RequestMapping("/" + RESTName.ADMIN)
public class AdminController extends ModuleController {

  @Autowired
  LanguageRepository languageRepo;
  @Autowired
  RoleRepository roleRepo;
  @Autowired
  LicenseRepository licenseRepo;
  @Autowired
  FundingAgencyRepository fundingAgencyRepo;
  @Autowired
  InstitutionRepository insitutionRepo;

  AdminController() {
    super(RESTName.ADMIN);
  }

  @Override
  @PostConstruct
  public void init() throws Exception {
    languageRepo.init();
    roleRepo.init();
    licenseRepo.init();
    fundingAgencyRepo.init();
    insitutionRepo.init();
  }

}
