package ch.dlcm.storage;

import java.nio.file.Path;
import java.nio.file.Paths;
import java.util.ArrayList;
import java.util.List;

import ch.dlcm.model.ArchiveMetadata;
import ch.dlcm.model.Package;
import ch.dlcm.service.PackageService;
import ch.dlcm.tool.FileTool;
import ch.dlcm.tool.XMLTool;
import ch.dlcm.tool.ZipTool;

public interface StorageService extends PackageService {

	public boolean indexPackage(String id);

	public boolean checkIndexing(String id);

	public boolean deleteIndex(String dlcmId);

	public default ArchiveMetadata getMetadata(String workingDir, String index, String id, String arcLocation) {
		List<String> metadataFiles = new ArrayList<>();
		String destination = workingDir + "/" + id;
		metadataFiles.add(Package.METADATAFILE.getName());
		metadataFiles.add(Package.METADATA.getName());
		ZipTool archive = new ZipTool(arcLocation);
		if (archive.unzipFiles(destination, metadataFiles)) {
			ArchiveMetadata metadata = null;
			if (Paths.get(destination + "/" + Package.METADATAFILE.getName()).toFile().exists()) {
				metadata = XMLTool.toArchiveMetadata(index, id, Paths.get(destination + "/" + Package.METADATAFILE.getName()));
				if (metadata != null) {
					metadata.getMetadata().put(Package.METADATAFILE.getName(), XMLTool.XML2String(Paths.get(destination + "/" + Package.METADATAFILE.getName())));
					if (Paths.get(destination + "/" + Package.METADATA.getName()).toFile().isDirectory()) {
						for (Path p : FileTool.readDirectory(destination + "/" + Package.METADATA.getName())) {
							metadata.getMetadata().put(p.getFileName().toString(), XMLTool.XML2String(p));
						}
					}
				}
			}
			return metadata;

		}
		return null;
	}

}
