package ch.dlcm.service;

import java.util.List;

import ch.dlcm.rest.RESTResource;

public interface ResourceService<T extends RESTResource<T>> {
    public List<T> findAll();
    
    public T findOne(String dlcmId);

    public T create(T resource);
    
    public T update(String dlcmId, T resource);
    
    public void delete(String dlcmId);
    
    public void searchByName(String name);

}
