package ch.dlcm.service.admin;

import java.util.List;

import ch.dlcm.model.FundingAgency;
import ch.dlcm.model.OrganizationalUnit;
import ch.dlcm.service.ResourceService;

public interface FundingAgencyService extends ResourceService<FundingAgency> {

  /**
   * Add a new {@link OrganizationalUnit} to a FundingAgency
   * 
   * @param fundingAgencyId
   * @param unitId
   */
  void addOrganizationalUnit(String fundingAgencyId, String unitId);
  
  /**
   * Remove a {@link OrganizationalUnit} from a FundingAgency
   * 
   * @param fundingAgencyId
   * @param unitId
   */
  void removeOrganizationalUnit(String fundingAgencyId, String unitId);
  
  /**
   * Get the list of {@link OrganizationalUnit} linked to a FundingAgency
   * 
   * @param fundingAgencyId
   */
  List<OrganizationalUnit> getOrganizationalUnits(String fundingAgencyId);
}

