package ch.dlcm.service.admin;

import java.util.List;

import org.springframework.stereotype.Service;

import ch.dlcm.model.FundingAgency;
import ch.dlcm.model.Institution;
import ch.dlcm.model.OrganizationalUnit;
import ch.dlcm.model.Person;
import ch.dlcm.model.Role;
import ch.dlcm.rest.RESTName;
import ch.dlcm.service.ResourceServiceREST;

@Service
public class FundingAgencyServiceREST extends ResourceServiceREST<FundingAgency> implements FundingAgencyService{
    
    private static final String fundingAgencyPath = "/" + RESTName.FUNDING_AGENCY;
    
    /********************************/
    
    public FundingAgencyServiceREST(){
        super(fundingAgencyPath, FundingAgency.class, RESTName.ADMIN);
    }
    
    /********************************/
    
    @Override
    public List<FundingAgency> findAll() {
        return findAll(FundingAgency.class);
    }
    
    @Override
    public void addOrganizationalUnit(String fundingAgencyId, String unitId) {
      this.addItem(fundingAgencyId, RESTName.UNIT, unitId, OrganizationalUnit.class);
    }

    @Override
    public void removeOrganizationalUnit(String fundingAgencyId, String unitId) {
      this.removeItem(fundingAgencyId, RESTName.UNIT, unitId);
    }

    @Override
    public List<OrganizationalUnit> getOrganizationalUnits(String fundingAgencyId) {
      return this.findAllLinkedResources(fundingAgencyId, OrganizationalUnit.class);
    }
}
