package ch.dlcm.service.admin;

import java.util.List;

import org.springframework.stereotype.Service;

import ch.dlcm.model.Institution;
import ch.dlcm.model.Person;
import ch.dlcm.rest.RESTName;
import ch.dlcm.service.ResourceServiceREST;

@Service
public class InstitutionServiceREST extends ResourceServiceREST<Institution> implements InstitutionService{
    
    private static final String institutionPath = "/" + RESTName.INSTITUTION;
    
    public InstitutionServiceREST(){
        super(institutionPath, Institution.class, RESTName.ADMIN);
    }
    @Override
    public List<Institution> findAll() {
        return findAll(Institution.class);
    }
    @Override
    public void addPerson(String institutionId, String personId){
        this.addItem(institutionId, "people", personId, Person.class);
    }
    @Override
    public List<Person> getPersons(String institutionId){
        return findAllLinkedResources(institutionId, Person.class);
    }
}
