package ch.dlcm.service.admin;

import java.util.List;

import ch.dlcm.model.Institution;
import ch.dlcm.model.OrganizationalUnit;
import ch.dlcm.model.Person;
import ch.dlcm.service.ResourceService;

public interface PersonService extends ResourceService<Person>{

    /**
     * Add a new institution to the project
     */
    void addInstitution(String personId, String institutionId);

    /**
     * Get list of institutions
     */
    List<Institution> getInstitutions(String personId);

    /**
     * Add a new project to the person and five the default role.
     */
    void addProject(String personDlcmId, String projectDlcmId);

    /**
     * Add a new project to the person with a list of roles
     */
    void addProject(String personId, String projectId, String... roleNames);

    /**
     * Get list of projects
     */
    List<OrganizationalUnit> getProjects(String personId);

    /**
     * Remove project from the person
     */
    void removeProject(String personId, String projectId);

    /**
     * Remove project with given role from a person
     */
    void removeProject(String personId, String projectId, String roleName);

}

