package ch.dlcm.service.archivalstorage;

import java.util.List;

import org.springframework.stereotype.Service;

import ch.dlcm.model.oais.AipDataFile;
import ch.dlcm.model.oais.ArchivalInfoPackage;
import ch.dlcm.rest.RESTName;
import ch.dlcm.service.ResourceServiceREST;

@Service
public class AIPServiceREST extends ResourceServiceREST<ArchivalInfoPackage> implements AIPService{
    
    private static final String aipPath = "/"+RESTName.AIP;
    
    public AIPServiceREST(){
        super(aipPath, ArchivalInfoPackage.class, RESTName.ARCHIVALSTORAGE);
    }
    @Override
    public List<ArchivalInfoPackage> findAll() {
        return findAll(ArchivalInfoPackage.class);
    }

	@Override
	public void addAipDataFile(String aipId, AipDataFile df) {
		this.addItem(aipId, "data", df, AipDataFile.class);
	}
	@Override
	public List<AipDataFile> getAipDataFile(String aipId) {
		return findAllLinkedResources(aipId, AipDataFile.class);
  }
  @Override
  public void removeAipDataFile(String aipId, String aipFileId) {
    this.removeItem(aipId, RESTName.DATAFILE, aipFileId);
  }
}