package ch.dlcm.service.ingest;

import java.util.List;

import org.springframework.stereotype.Service;

import ch.dlcm.model.oais.SipDataFile;
import ch.dlcm.model.oais.SubmissionInfoPackage;
import ch.dlcm.rest.RESTName;
import ch.dlcm.service.ResourceServiceREST;

@Service
public class SIPServiceREST extends ResourceServiceREST<SubmissionInfoPackage> implements SIPService{
    
    private static final String sipPath = "/"+RESTName.SIP;
    
    public SIPServiceREST(){
        super(sipPath, SubmissionInfoPackage.class, RESTName.INGEST);
    }
    @Override
    public List<SubmissionInfoPackage> findAll() {
        return findAll(SubmissionInfoPackage.class);
    }

	@Override
	public void addSipDataFile(String sipId, SipDataFile df) {
		this.addItem(sipId, "data", df, SipDataFile.class);
	}
	@Override
	public List<SipDataFile> getSipDataFile(String sipId) {
		return findAllLinkedResources(sipId, SipDataFile.class);
  }
  @Override
  public void removeSipDataFile(String sipId, String sipFileId) {
    this.removeItem(sipId, RESTName.DATAFILE, sipFileId);
  }
}