package ch.dlcm.test;

import static org.junit.Assert.assertTrue;

import java.util.concurrent.ThreadLocalRandom;
import java.util.concurrent.TimeUnit;

public class DLCMTestConstants {
  public final static String PREFIX = "[Test] ";
  public final static String EXCEEDED_TRIES = "Tries exceeded the limit";
  public final static int TRIES = 10;
  public final static int WAIT = 2;

  public static String getLabel(String text) {
    return DLCMTestConstants.PREFIX + text + ThreadLocalRandom.current().nextInt();
  }
  
  public static void checkTries(int count) {
    if (count > DLCMTestConstants.TRIES) {
      assertTrue(DLCMTestConstants.EXCEEDED_TRIES, false);
    }
    return;
  }

  public static void waitInSeconds() {
    try {
      TimeUnit.SECONDS.sleep(DLCMTestConstants.WAIT);
    } catch (InterruptedException e) {
      e.printStackTrace();
    }

  }
}
