package ch.dlcm.controller;

import static org.springframework.hateoas.mvc.ControllerLinkBuilder.linkTo;
import static org.springframework.hateoas.mvc.ControllerLinkBuilder.methodOn;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.hateoas.Link;
import org.springframework.http.HttpEntity;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import ch.dlcm.model.Module;
import ch.dlcm.rest.RESTAction;
import ch.dlcm.rest.RESTResource;
import ch.dlcm.service.ModuleService;

@RestController
public class ApplicationController{

	//private static final Logger log = Logger.getLogger(ApplicationController.class);

	@Value("${server.display-name}")
	private String DLCMname = null;

	@Autowired
    ModuleService<? extends RESTResource<?>> moduleService;

	@RequestMapping("/")
	public HttpEntity<Module> home() {
		Module backend = new Module(DLCMname);
		backend.add(linkTo(methodOn(ApplicationController.class).home()).withSelfRel());
		backend.add(new Link(linkTo(methodOn(ApplicationController.class).home())+RESTAction.DASHBOARD.toLowerCase()).withRel(RESTAction.DASHBOARD));
        for (ModuleController module : moduleService.getModuleControllerList()) {
			backend.add(linkTo(methodOn(module.getClass()).home()).withRel(module.getName()));
		}
		return new ResponseEntity<>(backend, HttpStatus.OK);
	}

}
