package ch.dlcm.controller;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;

import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.GetMapping;

import ch.dlcm.rest.RESTResource;
import ch.dlcm.service.ModuleService;

@Controller
public class DashboardController {

  @Autowired
  ModuleService<? extends RESTResource<?>> moduleService;

  @Value("${server.display-name}")
  private String dlcmApplicationName;

  @GetMapping("/dashboard")
  public String dashboard(Model model) {
    model.addAttribute("dlcmModules", moduleService.getModuleControllerList());
    model.addAttribute("dlcmApplicationName", dlcmApplicationName);
    return "dashboard";
  }
}
