package ch.dlcm.controller;

import java.util.Map;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.autoconfigure.web.ErrorAttributes;
import org.springframework.boot.autoconfigure.web.ErrorController;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;
import org.springframework.web.context.request.ServletRequestAttributes;

import ch.dlcm.rest.RESTError;
import ch.dlcm.rest.RESTName;

@RestController
public class JSONErrorController implements ErrorController {
	
	private static final boolean INCLUDE_STACK_TRACE = false;

	@Autowired
	private ErrorAttributes errorAttributes;

	@RequestMapping("/" + RESTName.ERROR)
	ResponseEntity<RESTError> error(HttpServletRequest request, HttpServletResponse response) {
	    Map<String, Object> mapErrorAttributes = errorAttributes.getErrorAttributes(new ServletRequestAttributes(request), INCLUDE_STACK_TRACE);
	    int status = (int)mapErrorAttributes.get("status");
	    RESTError error = new RESTError(mapErrorAttributes);
		return new ResponseEntity<>(error, HttpStatus.valueOf(status));
	}
	@Override
	public String getErrorPath() {
		return "/" + RESTName.ERROR;
	}
}
