
package ch.dlcm.repository;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.query.Param;
import org.springframework.stereotype.Repository;

import ch.dlcm.model.oais.AipDataFile;
import ch.dlcm.model.oais.ArchivalInfoPackage;
import ch.dlcm.rest.RESTRepository;

@Repository
public interface ArchivalInfoPackageRepository extends RESTRepository<ArchivalInfoPackage>{
	@Query("SELECT df FROM ArchivalInfoPackage a JOIN a.dataFiles df  WHERE a.dlcmId = :parentId")
	public Page<AipDataFile> findAipDataFileByParentId(@Param("parentId") String parentId, Pageable pageable);
	
	@Query("SELECT df FROM ArchivalInfoPackage a JOIN a.dataFiles df  WHERE a.dlcmId = :parentId AND df.dlcmId=:id")
	public AipDataFile findAipDataFileByParentId(@Param("parentId") String parentId, @Param("id") String id);

}