
package ch.dlcm.repository;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.query.Param;
import org.springframework.stereotype.Repository;

import ch.dlcm.model.oais.DipDataFile;
import ch.dlcm.model.oais.DisseminationInfoPackage;
import ch.dlcm.rest.RESTRepository;

@Repository
public interface DisseminationInfoPackageRepository extends RESTRepository<DisseminationInfoPackage>{
	@Query("SELECT df FROM DisseminationInfoPackage a JOIN a.dataFiles df  WHERE a.dlcmId = :parentId")
	public Page<DipDataFile> findDipDataFileByParentId(@Param("parentId") String parentId, Pageable pageable);
	
	@Query("SELECT df FROM DisseminationInfoPackage a JOIN a.dataFiles df  WHERE a.dlcmId = :parentId AND df.dlcmId=:id")
	public DipDataFile findDipDataFileByParentId(@Param("parentId") String parentId, @Param("id") String id);

}