package ch.dlcm.repository;

import java.util.List;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.PagingAndSortingRepository;
import org.springframework.data.repository.query.Param;

import ch.dlcm.model.StatusHistory;

public interface HistoryRepository extends PagingAndSortingRepository<StatusHistory, Long>{
	public List<StatusHistory> findByDlcmId(@Param("dlcmId") String dlcmId);
	public Page<StatusHistory> findByDlcmId(@Param("dlcmId") String dlcmId, Pageable pageable);
	@Query("SELECT s FROM StatusHistory s WHERE s.dlcmId = :dlcmId ORDER BY s.changeTime DESC")
	public List<StatusHistory> findLast(@Param("dlcmId") String dlcmId);
}
