package ch.dlcm.repository;

import ch.dlcm.model.OrganizationalUnitPersonRole;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.query.Param;
import org.springframework.stereotype.Repository;

@Repository
public interface OrganizationalUnitPersonRoleRepository {

  @Query("SELECT oupr FROM OrganizationalUnit u JOIN u.organizationalUnitPersonRoles oupr WHERE oupr.dlcmCompositeId.organizationalUnit.dlcmId = :projectId AND oupr.dlcmCompositeId.person.dlcmId = :personId AND oupr.dlcmCompositeId.role.dlcmId=:roleId")
  OrganizationalUnitPersonRole findByCompositeId(@Param("projectId") String projectId, @Param("personId") String personId, @Param("roleId") String roleId);

}