package ch.dlcm.repository;


import ch.dlcm.model.Institution;
import ch.dlcm.model.OrganizationalUnit;
import ch.dlcm.model.Person;
import ch.dlcm.rest.RESTRepository;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.query.Param;
import org.springframework.stereotype.Repository;

@Repository
public interface PersonRepository extends RESTRepository<Person>, OrganizationalUnitPersonRoleRepository {

	@Query("SELECT i FROM Person p JOIN p.institutions i WHERE p.dlcmId = :parentId")
	Page<Institution> findInstitutionsByParentId(@Param("parentId") String parentId, Pageable pageable);
	
	@Query("SELECT i FROM Person p JOIN p.institutions i WHERE p.dlcmId = :parentId AND i.dlcmId=:id")
	Institution findInstitutionsByParentId(@Param("parentId") String parentId, @Param("id") String id);
	
	@Query("SELECT distinct oupr.dlcmCompositeId.organizationalUnit FROM Person p JOIN p.organizationalUnitPersonRoles oupr WHERE oupr.dlcmCompositeId.person.dlcmId = :parentId")
	Page<OrganizationalUnit> findProjectsByParentId(@Param("parentId") String parentId, Pageable pageable);

  @Query("SELECT oupr.dlcmCompositeId.organizationalUnit FROM Person p JOIN p.organizationalUnitPersonRoles oupr WHERE oupr.dlcmCompositeId.person.dlcmId = :parentId AND oupr.dlcmCompositeId.organizationalUnit.dlcmId=:id")
	OrganizationalUnit findProjectsByParentId(@Param("parentId") String parentId, @Param("id") String id);

}