
package ch.dlcm.repository;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.query.Param;
import org.springframework.stereotype.Repository;

import ch.dlcm.model.oais.SipDataFile;
import ch.dlcm.model.oais.SubmissionInfoPackage;
import ch.dlcm.rest.RESTRepository;

@Repository
public interface SubmissionInfoPackageRepository extends RESTRepository<SubmissionInfoPackage>{
	@Query("SELECT df FROM SubmissionInfoPackage s JOIN s.dataFiles df  WHERE s.dlcmId = :parentId")
	public Page<SipDataFile> findSipDataFileByParentId(@Param("parentId") String parentId, Pageable pageable);
	
	@Query("SELECT df FROM SubmissionInfoPackage s JOIN s.dataFiles df  WHERE s.dlcmId = :parentId AND df.dlcmId=:id")
	public SipDataFile findSipDataFileByParentId(@Param("parentId") String parentId, @Param("id") String id);
}