package ch.dlcm.rest;

import java.util.Map;

import org.apache.log4j.Logger;

import ch.dlcm.controller.JSONErrorController;

public class RESTError {
    private static final Logger log = Logger.getLogger(JSONErrorController.class);

	private final String  path;
	private final Integer status;
	private final String  error;
	private final String  message;
	private final String  timeStamp;

    public RESTError(Map<String, Object> errorAttributes) {
        this.path      = (String) errorAttributes.get("path");
        this.status    = (Integer)errorAttributes.get("status");
        this.error     = (String) errorAttributes.get("error");
        this.message   = (String) errorAttributes.get("message");
        this.timeStamp = errorAttributes.get("timestamp").toString();
        log();
    }
    
    private void log(){
    	log.error(status+" status on "+path+" @ "+timeStamp);
    }

	public String getPath() {
		return path;
	}

	public Integer getStatus() {
		return status;
	}

	public String getError() {
		return error;
	}

	public String getMessage() {
		return message;
	}

	public String getTimeStamp() {
		return timeStamp;
	}
}
