package ch.dlcm.service;

import org.apache.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.event.EventListener;
import org.springframework.jms.core.JmsTemplate;
import org.springframework.stereotype.Component;

import ch.dlcm.message.AipDownloadMessage;
import ch.dlcm.message.AipMessage;
import ch.dlcm.message.DataFileMessage;
import ch.dlcm.message.DepositMessage;
import ch.dlcm.message.DipMessage;
import ch.dlcm.message.OrderMessage;
import ch.dlcm.message.SipMessage;
import ch.dlcm.model.StatusHistory;

@Component
public class JmsService extends DLCMService {
    private static final Logger log = Logger.getLogger(JmsService.class);
	
	@Autowired
    private JmsTemplate jmsTemplate;

	@Override
	protected void loadConfig() {		
	}
	
	@EventListener
	private void sendMessage(StatusHistory event) {
		String queue = this.dlcmConfig.getHistoryQueue();
		convertAndSend(queue, event);
	}
	
	@EventListener
	private void sendMessage(DataFileMessage event) {
		String queue = this.dlcmConfig.getDataFileQueue();
		convertAndSend(queue, event);
	}

	@EventListener
	private void sendMessage(DepositMessage event) {
		String queue = this.dlcmConfig.getDepositQueue();
		convertAndSend(queue, event);
	}
	
	@EventListener
	private void sendMessage(OrderMessage event) {
		String queue = this.dlcmConfig.getOrderQueue();
		convertAndSend(queue, event);
	}
	
	@EventListener
	private void sendMessage(SipMessage event) {
		String queue = this.dlcmConfig.getSipQueue();
		convertAndSend(queue, event);
	}
	
	@EventListener
	private void sendMessage(AipMessage event) {
		String queue = this.dlcmConfig.getAipQueue();
		convertAndSend(queue, event);
	}
	
	@EventListener
  private void sendMessage(AipDownloadMessage event) {
    String queue = this.dlcmConfig.getAipDownloadQueue();
    convertAndSend(queue, event);
  }
	
	@EventListener
	private void sendMessage(DipMessage event) {
		String queue = this.dlcmConfig.getDipQueue();
		convertAndSend(queue, event);
	}

	private void convertAndSend(String queue, Object event) {
		log.trace("Sending message to "+ queue +" => "+ event.toString());
		jmsTemplate.convertAndSend(queue, event);
	}

}
