package ch.dlcm.service;

import java.util.Locale;

import javax.annotation.PostConstruct;

import org.apache.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.MessageSource;
import org.springframework.context.NoSuchMessageException;
import org.springframework.context.support.MessageSourceAccessor;
import org.springframework.stereotype.Service;

@Service
public class MessageService {
	private static final Logger log = Logger.getLogger(MessageService.class);


	@Autowired
	private MessageSource messageSource;

	private MessageSourceAccessor accessor;

	@PostConstruct
	private void init() {
		accessor = new MessageSourceAccessor(messageSource, Locale.ENGLISH);
	}

	public String get(String code) {
		try{
			return accessor.getMessage(code);
		}catch(NoSuchMessageException e){
			log.error("Cannot find message", e);
			return accessor.getMessage("message.not.found",new Object [] {code});
		}
	}

	public String get(String code, Object[] args) {
		try{
			return accessor.getMessage(code, args);
		}catch(NoSuchMessageException e){
			log.error("Cannot find message", e);
			return accessor.getMessage("message.not.found",new Object [] {code});
		}
	}

}