package ch.dlcm.controller.datamgmt;

import static org.springframework.hateoas.mvc.ControllerLinkBuilder.linkTo;
import static org.springframework.hateoas.mvc.ControllerLinkBuilder.methodOn;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.hateoas.ResourceSupport;
import org.springframework.http.HttpEntity;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import ch.dlcm.controller.ResourceNoSqlController;
import ch.dlcm.model.ArchiveMetadata;
import ch.dlcm.rest.RESTAction;
import ch.dlcm.rest.RESTCollection;
import ch.dlcm.rest.RESTName;
import ch.dlcm.rest.RESTTool;

@RestController
@RequestMapping("/" + RESTName.DATAMGMT + "/" + RESTName.DI)
public class DIController extends ResourceNoSqlController<ArchiveMetadata> {


	@RequestMapping(value = "/" + RESTName.SEARCH, method = RequestMethod.GET)
	public HttpEntity<RESTCollection<ArchiveMetadata>> search(@RequestParam(defaultValue="*") String query, Pageable pageable) {
		final Page<ArchiveMetadata> listItem = itemRepository.search(query,pageable);
		for (final ArchiveMetadata t : listItem) {
			addLinks(t);
		}
		RESTCollection<ArchiveMetadata> collection = new RESTCollection<>(listItem, pageable);
		collection.add(linkTo(methodOn(this.getClass()).search(query, pageable)).withSelfRel());
		collection.add(RESTTool.parentLink((linkTo(this.getClass(), query, pageable)).toUriComponentsBuilder()).withRel(RESTAction.MODULE));
		this.addPageLinks(linkTo(methodOn(this.getClass()).search(query, pageable)), collection, pageable);
		this.addOthersLinks(collection);
		return new ResponseEntity<>(collection, HttpStatus.OK);
	}
	
	@Override
	protected <W extends ResourceSupport> boolean addOthersLinks(W w) {
		w.add(linkTo(methodOn(this.getClass()).search(null, null)).withRel(RESTAction.SEARCH));
		return true;
	}
}