package ch.dlcm.ingestion.bagit;

import java.util.List;

import javax.annotation.PostConstruct;

import org.springframework.context.annotation.Profile;
import org.springframework.stereotype.Service;

import ch.dlcm.ingestion.IngestionService;
import ch.dlcm.model.Status.StatusValue;
import ch.dlcm.service.DLCMService;
import ch.dlcm.tool.ZipTool;

@Profile("ing-bagit")
@Service
public class BagItIngestionService extends DLCMService implements IngestionService {


	private String ingestionPath;

	@PostConstruct
	@Override
	protected void loadConfig(){
		this.ingestionPath = this.dlcmConfig.getIngestLocation();
	}

	@Override
	public boolean checkPackage(String id) {
		ZipTool zipTool = new ZipTool(this.getPackageUri(id));
		return zipTool.checkZip();
	}

	@Override
	public String submitPackage(String id, String name) {
		return id;
	}

	@Override
	public StatusValue getStatus(String id) {
		if (!this.checkPackage(id)){
			return StatusValue.InError;
		}
		return StatusValue.Completed;
	}

	@Override
	public String getPackageUri(String id) {
		return this.ingestionPath + "/" + id + "/sip";
	}

	@Override
	public String sendPackage(String id, String name) {
		return this.sendAIP(id, name);
	}

	@Override
	public List<?> listPackages() {
		throw new UnsupportedOperationException();
	}

}
