package ch.dlcm.criteria;

import java.util.ArrayList;
import java.util.List;

import javax.persistence.criteria.CriteriaBuilder;
import javax.persistence.criteria.CriteriaQuery;
import javax.persistence.criteria.Predicate;
import javax.persistence.criteria.Root;

import org.springframework.data.jpa.domain.Specification;

import ch.dlcm.model.oais.AipDataFile;

public class AipDataFileSpecification extends DataFileSpecification<AipDataFile> implements Specification<AipDataFile> {

	private final AipDataFile criteria;

	public AipDataFileSpecification(AipDataFile criteria) {
		this.criteria = criteria;
	}

	@Override
	public Predicate toPredicate(Root<AipDataFile> root, CriteriaQuery<?> query, CriteriaBuilder builder) {
		List<Predicate> listPredicate = new ArrayList<>();
		if (criteria.getDataFile() != null) {
			setDataFileCriteria(root, builder, listPredicate, criteria.getDataFile());
		}
		return builder.and(listPredicate.toArray(new Predicate[listPredicate.size()]));
	}
}
