package ch.dlcm.criteria;

import java.util.ArrayList;
import java.util.List;

import javax.persistence.criteria.CriteriaBuilder;
import javax.persistence.criteria.CriteriaQuery;
import javax.persistence.criteria.Predicate;
import javax.persistence.criteria.Root;

import org.springframework.data.jpa.domain.Specification;

import ch.dlcm.model.oais.ArchivalInfoPackage;

public class ArchivalInfoPackageSpecification extends RepresentationInfoSpecification<ArchivalInfoPackage> implements Specification<ArchivalInfoPackage> {

	private final ArchivalInfoPackage criteria;

	public ArchivalInfoPackageSpecification(ArchivalInfoPackage criteria) {
		this.criteria = criteria;
	}

	@Override
	public Predicate toPredicate(Root<ArchivalInfoPackage> root, CriteriaQuery<?> query, CriteriaBuilder builder) {
		List<Predicate> listPredicate = new ArrayList<>();
		if (criteria.getInfo() != null) {
			setRepresentationInfoCriteria(root, builder, listPredicate, criteria.getInfo());
		}
		if (criteria.getArchiveId() != null){
			listPredicate.add(builder.like(root.get("archiveId"), "%" + criteria.getArchiveId() + "%"));
		}
		return builder.and(listPredicate.toArray(new Predicate[listPredicate.size()]));
	}
}