package ch.dlcm.criteria;

import java.util.List;

import javax.persistence.criteria.CriteriaBuilder;
import javax.persistence.criteria.Path;
import javax.persistence.criteria.Predicate;
import javax.persistence.criteria.Root;

import ch.dlcm.model.DataFile;
import ch.dlcm.model.DataFileInterface;

public abstract class DataFileSpecification<T extends DataFileInterface> {

	protected void setDataFileCriteria(Root<T> root, CriteriaBuilder builder,List<Predicate> listPredicate, DataFile df) {
		Path<DataFile> proxy = root.get("dataFile");
		if (df.getSourceData() != null) {
			listPredicate.add(builder.like(proxy.get("sourceData"), "%" + df.getSourceData() + "%"));
		}
		if (df.getFinalData() != null) {
			listPredicate.add(builder.like(proxy.get("finalData"), "%" + df.getFinalData() + "%"));
		}
		if(df.getStatus().getValue() != null){
			listPredicate.add(builder.equal(proxy.get("status").get("value"), df.getStatus().getValue()));        	
	    }
	    if(df.getStatus().getInfo() != null){
	        listPredicate.add(builder.equal(proxy.get("status").get("info"), df.getStatus().getInfo()));        	
		}
	    if (df.getDataCategory() != null) {
			listPredicate.add(builder.equal(proxy.get("dataCategory"), df.getDataCategory()));
		}
	    if (df.getSize() > 0) {
			listPredicate.add(builder.greaterThanOrEqualTo(proxy.get("size"), df.getSize()));
		}

	}	
}
