package ch.dlcm.criteria;

import java.util.ArrayList;
import java.util.List;

import javax.persistence.criteria.CriteriaBuilder;
import javax.persistence.criteria.CriteriaQuery;
import javax.persistence.criteria.Predicate;
import javax.persistence.criteria.Root;

import org.springframework.data.jpa.domain.Specification;

import ch.dlcm.model.DepositDataFile;

public class DepositDataFileSpecification extends DataFileSpecification<DepositDataFile> implements Specification<DepositDataFile> {

	private final DepositDataFile criteria;

	public DepositDataFileSpecification(DepositDataFile criteria) {
		this.criteria = criteria;
	}

	@Override
	public Predicate toPredicate(Root<DepositDataFile> root, CriteriaQuery<?> query, CriteriaBuilder builder) {
		List<Predicate> listPredicate = new ArrayList<>();
		if (criteria.getDataFile() != null) {
			setDataFileCriteria(root, builder, listPredicate, criteria.getDataFile());
		}
		return builder.and(listPredicate.toArray(new Predicate[listPredicate.size()]));
	}

}
