package ch.dlcm.criteria;

import java.util.ArrayList;
import java.util.List;

import javax.persistence.criteria.CriteriaBuilder;
import javax.persistence.criteria.CriteriaQuery;
import javax.persistence.criteria.Predicate;
import javax.persistence.criteria.Root;

import org.springframework.data.jpa.domain.Specification;

import ch.dlcm.model.Deposit;

public class DepositSpecification implements Specification<Deposit>{
    
    private final Deposit criteria;
    
    public DepositSpecification(Deposit criteria) {
        this.criteria=criteria;
    }

    @Override
    public Predicate toPredicate(Root<Deposit> root, CriteriaQuery<?> query, CriteriaBuilder builder) {
        List<Predicate> listPredicate = new ArrayList<>();
        if(criteria.getTitle() != null){
            listPredicate.add(builder.like(root.get("title"), "%" + criteria.getTitle() + "%"));
        }
        if(criteria.getStatus().getValue() != null){
        	listPredicate.add(builder.equal(root.get("status").get("value"), criteria.getStatus().getValue()));        	
        }
        if(criteria.getStatus().getInfo() != null){
        	listPredicate.add(builder.equal(root.get("status").get("info"), criteria.getStatus().getInfo()));        	
        }

        if(criteria.getYear() != null){
            listPredicate.add(builder.equal(root.get("year"), criteria.getYear()));
        }
        return builder.and(listPredicate.toArray(new Predicate[listPredicate.size()])); 
    }

}
