package ch.dlcm.criteria;

import java.util.ArrayList;
import java.util.List;

import javax.persistence.criteria.CriteriaBuilder;
import javax.persistence.criteria.CriteriaQuery;
import javax.persistence.criteria.Predicate;
import javax.persistence.criteria.Root;

import org.springframework.data.jpa.domain.Specification;

import ch.dlcm.model.oais.DisseminationInfoPackage;


public class DisseminationInfoPackageSpecification extends RepresentationInfoSpecification<DisseminationInfoPackage> implements Specification<DisseminationInfoPackage>{

    private final DisseminationInfoPackage criteria;

    public DisseminationInfoPackageSpecification(DisseminationInfoPackage criteria) {
        this.criteria=criteria;
    }

	@Override
    public Predicate toPredicate(Root<DisseminationInfoPackage> root, CriteriaQuery<?> query, CriteriaBuilder builder) {
        List<Predicate> listPredicate = new ArrayList<>();
        if (criteria.getInfo() != null) {
			setRepresentationInfoCriteria(root, builder, listPredicate, criteria.getInfo());
		}
        return builder.and(listPredicate.toArray(new Predicate[listPredicate.size()]));
    }
}