package ch.dlcm.criteria;

import java.util.ArrayList;
import java.util.List;

import javax.persistence.criteria.CriteriaBuilder;
import javax.persistence.criteria.CriteriaQuery;
import javax.persistence.criteria.Predicate;
import javax.persistence.criteria.Root;

import org.springframework.data.jpa.domain.Specification;

import ch.dlcm.model.FundingAgency;

public class FundingAgencySpecification  implements Specification<FundingAgency>{

    private final FundingAgency criteria;

    public FundingAgencySpecification(FundingAgency criteria) {
        this.criteria = criteria;
    }

    @Override
    public Predicate toPredicate(Root<FundingAgency> root, CriteriaQuery<?> query, CriteriaBuilder builder) {
      
      List<Predicate> listPredicate = new ArrayList<>();
      
      if(criteria.getName() != null){
        listPredicate.add(builder.like(root.get("name"), "%" + criteria.getName() + "%"));
      }
      
      if(criteria.getAcronym() != null){
        listPredicate.add(builder.like(root.get("acronym"), "%" + criteria.getAcronym() + "%"));
      }
      
      if(criteria.getDescription() != null){
        listPredicate.add(builder.like(root.get("description"), "%" + criteria.getDescription() + "%"));
      }
      
      if(criteria.getUrl() != null){
        listPredicate.add(builder.like(root.get("url"), "%" + criteria.getUrl() + "%"));
      }
      
      return builder.and(listPredicate.toArray(new Predicate[listPredicate.size()]));
    }
}