package ch.dlcm.criteria;

import ch.dlcm.model.Language;
import org.springframework.data.jpa.domain.Specification;

import javax.persistence.criteria.CriteriaBuilder;
import javax.persistence.criteria.CriteriaQuery;
import javax.persistence.criteria.Predicate;
import javax.persistence.criteria.Root;
import java.util.ArrayList;
import java.util.List;

public class LanguageSpecification implements Specification<Language> {

    private Language language;

    public LanguageSpecification(Language language) {
        this.language = language;
    }

    @Override
    public Predicate toPredicate(Root<Language> root, CriteriaQuery<?> query, CriteriaBuilder criteriaBuilder) {
        List<Predicate> listPredicate = new ArrayList<>();
        if(language.getCode() != null){
            listPredicate.add(criteriaBuilder.like(root.get("code"), "%" + language.getCode() + "%"));
        }
        return criteriaBuilder.and(listPredicate.toArray(new Predicate[listPredicate.size()]));
    }
}
