package ch.dlcm.criteria;

import java.util.ArrayList;
import java.util.List;

import javax.persistence.criteria.CriteriaBuilder;
import javax.persistence.criteria.CriteriaQuery;
import javax.persistence.criteria.Predicate;
import javax.persistence.criteria.Root;

import org.springframework.data.jpa.domain.Specification;

import ch.dlcm.model.License;

public class LicenseSpecification implements Specification<License> {

    private License license;

    public LicenseSpecification(License license) {
        this.license = license;
    }

    @Override
    public Predicate toPredicate(Root<License> root, CriteriaQuery<?> query, CriteriaBuilder criteriaBuilder) {
        List<Predicate> listPredicate = new ArrayList<>();
        if(license.getTitle() != null){
            listPredicate.add(criteriaBuilder.like(root.get("title"), "%" + license.getTitle() + "%"));
        }
        if(license.getOpenLicenseId() != null){
            listPredicate.add(criteriaBuilder.like(root.get("open-licence-id"), "%" + license.getOpenLicenseId() + "%"));
        }
        if(license.getStatus() != null){
            listPredicate.add(criteriaBuilder.like(root.get("status"), "%" + license.getStatus() + "%"));
        }
        if(license.getUrl() != null){
            listPredicate.add(criteriaBuilder.like(root.get("url"), "%" + license.getUrl() + "%"));
        }
        if(license.getFamily() != null){
            listPredicate.add(criteriaBuilder.like(root.get("family"), "%" + license.getFamily() + "%"));
        }
        return criteriaBuilder.and(listPredicate.toArray(new Predicate[listPredicate.size()]));
    }
}
