package ch.dlcm.criteria;

import java.util.ArrayList;
import java.util.List;

import javax.persistence.criteria.CriteriaBuilder;
import javax.persistence.criteria.CriteriaQuery;
import javax.persistence.criteria.Predicate;
import javax.persistence.criteria.Root;

import org.springframework.data.jpa.domain.Specification;

import ch.dlcm.model.OrganizationalUnit;


public class OrganizationalUnitSpecification implements Specification<OrganizationalUnit>{

    private final OrganizationalUnit criteria;

    public OrganizationalUnitSpecification(OrganizationalUnit criteria) {
        this.criteria=criteria;
    }

    @Override
    public Predicate toPredicate(Root<OrganizationalUnit	> root, CriteriaQuery<?> query, CriteriaBuilder builder) {
        List<Predicate> listPredicate = new ArrayList<>();
        if(criteria.getName() != null){
            listPredicate.add(builder.like(root.get("name"), "%" + criteria.getName() + "%"));
        }
        if(criteria.getDescription() != null){
            listPredicate.add(builder.like(root.get("description"), "%" + criteria.getDescription() + "%"));
        }
        return builder.and(listPredicate.toArray(new Predicate[listPredicate.size()]));
    }
}