package ch.dlcm.criteria;

import java.util.ArrayList;
import java.util.List;

import javax.persistence.criteria.CriteriaBuilder;
import javax.persistence.criteria.CriteriaQuery;
import javax.persistence.criteria.Predicate;
import javax.persistence.criteria.Root;

import org.springframework.data.jpa.domain.Specification;

import ch.dlcm.model.Person;

public class PersonSpecification  implements Specification<Person>{

    private final Person criteria;

    public PersonSpecification(Person criteria) {
        this.criteria=criteria;
    }

    @Override
    public Predicate toPredicate(Root<Person> root, CriteriaQuery<?> query, CriteriaBuilder builder) {
        List<Predicate> listPredicate = new ArrayList<>();
        if(criteria.getFirstName() != null){
            listPredicate.add(builder.like(root.get("firstName"), "%" + criteria.getFirstName() + "%"));
        }
        if(criteria.getLastName() != null){
            listPredicate.add(builder.like(root.get("lastName"), "%" + criteria.getLastName() + "%"));
        }
        return builder.and(listPredicate.toArray(new Predicate[listPredicate.size()]));
    }
}