package ch.dlcm.criteria;

import java.util.List;

import javax.persistence.criteria.CriteriaBuilder;
import javax.persistence.criteria.Path;
import javax.persistence.criteria.Predicate;
import javax.persistence.criteria.Root;

import ch.dlcm.model.oais.InfoPackageInterface;
import ch.dlcm.model.oais.RepresentationInfo;

public abstract class RepresentationInfoSpecification<T extends InfoPackageInterface> {

	protected void setRepresentationInfoCriteria(Root<T> root, CriteriaBuilder builder,
			List<Predicate> listPredicate, RepresentationInfo info) {
		Path<RepresentationInfo> proxy = root.get("info");
		if (info.getName() != null) {
			listPredicate.add(builder.like(proxy.get("name"), "%" + info.getName() + "%"));
		}
		if (info.getDescription() != null) {
			listPredicate.add(builder.like(proxy.get("description"), "%" + info.getDescription() + "%"));
		}
		if(info.getStatus().getValue() != null){
			listPredicate.add(builder.equal(proxy.get("status").get("value"), info.getStatus().getValue()));        	
	    }
	    if(info.getStatus().getInfo() != null){
	        listPredicate.add(builder.equal(proxy.get("status").get("info"), info.getStatus().getInfo()));        	
		}
		
	}	
}
