package ch.dlcm.criteria;

import ch.dlcm.model.Role;
import org.springframework.data.jpa.domain.Specification;

import javax.persistence.criteria.CriteriaBuilder;
import javax.persistence.criteria.CriteriaQuery;
import javax.persistence.criteria.Predicate;
import javax.persistence.criteria.Root;
import java.util.ArrayList;
import java.util.List;

public class RoleSpecification implements Specification<Role> {

    private Role role;

    public RoleSpecification(Role role) {
        this.role = role;
    }

    @Override
    public Predicate toPredicate(Root<Role> root, CriteriaQuery<?> query, CriteriaBuilder criteriaBuilder) {
        List<Predicate> listPredicate = new ArrayList<>();
        if(role.getName() != null){
            listPredicate.add(criteriaBuilder.like(root.get("name"), "%" + role.getName() + "%"));
        }
        return criteriaBuilder.and(listPredicate.toArray(new Predicate[listPredicate.size()]));
    }
}
