package ch.dlcm.criteria;

import ch.dlcm.model.SubmissionAgreement;
import org.springframework.data.jpa.domain.Specification;

import javax.persistence.criteria.CriteriaBuilder;
import javax.persistence.criteria.CriteriaQuery;
import javax.persistence.criteria.Predicate;
import javax.persistence.criteria.Root;
import java.util.ArrayList;
import java.util.List;

public class SubmissionAgreementSpecification implements Specification<SubmissionAgreement> {

    private SubmissionAgreement submissionAgreement;

    public SubmissionAgreementSpecification(SubmissionAgreement submissionAgreement) {
        this.submissionAgreement = submissionAgreement;
    }

    @Override
    public Predicate toPredicate(Root<SubmissionAgreement> root, CriteriaQuery<?> query, CriteriaBuilder criteriaBuilder) {
        List<Predicate> listPredicate = new ArrayList<>();
        if(submissionAgreement.getTitle() != null){
            listPredicate.add(criteriaBuilder.like(root.get("title"), "%" + submissionAgreement.getTitle() + "%"));
        }
        if(submissionAgreement.getDescription() != null){
            listPredicate.add(criteriaBuilder.like(root.get("description"), "%" + submissionAgreement.getDescription() + "%"));
        }
        if(submissionAgreement.getVersion() != null){
            listPredicate.add(criteriaBuilder.like(root.get("version"), "%" + submissionAgreement.getVersion() + "%"));
        }
        return criteriaBuilder.and(listPredicate.toArray(new Predicate[listPredicate.size()]));
    }

}