package ch.dlcm.criteria;

import java.util.ArrayList;
import java.util.List;

import javax.persistence.criteria.CriteriaBuilder;
import javax.persistence.criteria.CriteriaQuery;
import javax.persistence.criteria.Predicate;
import javax.persistence.criteria.Root;

import org.springframework.data.jpa.domain.Specification;

import ch.dlcm.model.oais.SubmissionInfoPackage;

public class SubmissionInfoPackageSpecification extends RepresentationInfoSpecification<SubmissionInfoPackage> implements Specification<SubmissionInfoPackage> {

	private final SubmissionInfoPackage criteria;

	public SubmissionInfoPackageSpecification(SubmissionInfoPackage criteria) {
		this.criteria = criteria;
	}

	@Override
	public Predicate toPredicate(Root<SubmissionInfoPackage> root, CriteriaQuery<?> query, CriteriaBuilder builder) {
		List<Predicate> listPredicate = new ArrayList<>();
		if (criteria.getInfo() != null) {
			setRepresentationInfoCriteria(root, builder, listPredicate, criteria.getInfo());
		}
		if (criteria.getDepositId() != null){
			listPredicate.add(builder.like(root.get("depositId"), "%" + criteria.getDepositId() + "%"));
		}
		if (criteria.getAipId() != null){
			listPredicate.add(builder.like(root.get("aipId"), "%" + criteria.getAipId() + "%"));
		}
		return builder.and(listPredicate.toArray(new Predicate[listPredicate.size()]));
	}

}