package ch.dlcm.listener;

import javax.persistence.PostPersist;
import javax.persistence.PostRemove;
import javax.persistence.PostUpdate;

import ch.dlcm.config.ContextHelper;
import ch.dlcm.model.DataFileInterface;
import ch.dlcm.model.Deposit;
import ch.dlcm.model.Order;
import ch.dlcm.model.StatusHistory;
import ch.dlcm.model.oais.InfoPackageInterface;
import ch.dlcm.rest.RESTResource;

public class HistoryListener {

	@PostPersist
	private void logCreation(Object object) {
		RESTResource<?> res = (RESTResource<?>) object;
		StatusHistory stsHistory = new StatusHistory(res.getClass().getSimpleName(), res.getDlcmId(), res.getCreationTime());
		ContextHelper.getPublisher().publishEvent(stsHistory);
	}

	@PostUpdate
	@PostRemove
	private void logEvent(Object object) {
		StatusHistory stsHistory=null;
		if (object instanceof Deposit){
			Deposit deposit = (Deposit) object;
			stsHistory = new StatusHistory(deposit.getClass().getSimpleName(), deposit.getDlcmId(), deposit.getUpdateTime(), deposit.getStatus().getValue().toString(), deposit.getStatus().getInfo());
		}else if (object instanceof DataFileInterface){
			RESTResource<?> res = (RESTResource<?>) object;
			DataFileInterface df = (DataFileInterface) object;
			stsHistory = new StatusHistory(res.getClass().getSimpleName(), res.getDlcmId(), res.getUpdateTime(), df.getDataFile().getStatus().getValue().toString(), df.getDataFile().getStatus().getInfo());
		}else if (object instanceof InfoPackageInterface){
			RESTResource<?> res = (RESTResource<?>) object;
			InfoPackageInterface ip = (InfoPackageInterface) object;
			stsHistory = new StatusHistory(res.getClass().getSimpleName(), res.getDlcmId(), res.getUpdateTime(), ip.getInfo().getStatus().getValue().toString(), ip.getInfo().getStatus().getInfo());
		}else if (object instanceof Order){
			Order order = (Order) object;
			stsHistory = new StatusHistory(order.getClass().getSimpleName(), order.getDlcmId(), order.getUpdateTime(), order.getStatus().getValue().toString(), order.getStatus().getInfo());
		}
		ContextHelper.getPublisher().publishEvent(stsHistory);
	}

}
