package ch.dlcm.listener;

import javax.persistence.PostUpdate;

import ch.dlcm.config.ContextHelper;
import ch.dlcm.message.DepositMessage;
import ch.dlcm.message.OrderMessage;
import ch.dlcm.model.Deposit;
import ch.dlcm.model.Order;
import ch.dlcm.model.Status.StatusValue;

public class PackageListener {

	@PostUpdate
	private void logEvent(Object object) {
		if (object instanceof Deposit) {
			logDeposit((Deposit) object);
		}
		if (object instanceof Order){
			logOrder((Order) object);
		}
	}

	private void logOrder(Order o) {
		if (o.getStatus().getValue() == StatusValue.Submitted) {
			ContextHelper.getPublisher().publishEvent(new OrderMessage(o.getDlcmId()));
		}
	}

	private void logDeposit(Deposit d) {
		if (d.getStatus().getValue() == StatusValue.Approved) {
			ContextHelper.getPublisher().publishEvent(new DepositMessage(d.getDlcmId()));
		}
	}

}
