package ch.dlcm.model;

import java.io.IOException;

import com.fasterxml.jackson.core.JsonParser;
import com.fasterxml.jackson.databind.DeserializationContext;
import com.fasterxml.jackson.databind.JsonDeserializer;
import com.fasterxml.jackson.databind.JsonNode;

public class ArchiveIndexDeserializer extends JsonDeserializer<ArchiveIndex> {
  
    @Override
    public ArchiveIndex deserialize(JsonParser jp, DeserializationContext ctxt) throws IOException {
        JsonNode node = jp.getCodec().readTree(jp);
        ArchiveIndex ai = new ArchiveIndex();
        ai.setDlcmId(node.get("dlcmId").asText());
        if (node.has("settings")){
        	ai.setSettings(node.findValue("settings").toString());
        }
        return ai;
    }
}