package ch.dlcm.model;

import java.util.HashMap;
import java.util.Map;
import java.util.Objects;

import com.fasterxml.jackson.databind.annotation.JsonDeserialize;

import ch.dlcm.rest.RESTResourceNoSql;

@JsonDeserialize(using=ArchiveMetadataDeserializer.class)
public class ArchiveMetadata extends RESTResourceNoSql<ArchiveMetadata> {
	
	private String index;
	private String type;
	private Map<String, Object> metadata = new HashMap<>();
	
	@Override
	public boolean equals(final Object other) {
		if (!(other instanceof ArchiveMetadata)) {
			return false;
		}
		ArchiveMetadata castOther = (ArchiveMetadata) other;
		return Objects.equals(index, castOther.index) && Objects.equals(type, castOther.type)
				&& Objects.equals(metadata, castOther.metadata);
	}

	@Override
	public int hashCode() {
		return Objects.hash(index, type, metadata);
	}

	public String getIndex() {
		return index;
	}
	
	public void setIndex(String index) {
		this.index = index;
	}
	
	public String getType() {
		return type;
	}
	
	public void setType(String type) {
		this.type = type;
	}
	
	public Map<String, Object> getMetadata() {
		return metadata;
	}

	public void setMetadata(Map<String, Object> metadata) {
		this.metadata = metadata;
	}

	public void setMetadata(String metadata) {
		this.metadata = this.convertString2Map(metadata);
	}
	
	public boolean check() {
		if (this.getDlcmId() == null || this.index == null  || this.type == null || this.metadata.isEmpty()){
			return false;
		}
		return true;
	}

	@Override
	public String toString() {
		return "ArchiveMetadata [index=" + index + ", type=" + type + ", metadata=" + metadata + "]";
	}

	@Override
	public boolean update(RESTResourceNoSql<ArchiveMetadata> item) {
		// TODO Auto-generated method stub
		return false;
	}
	
	

}
