package ch.dlcm.model;

import java.io.IOException;

import com.fasterxml.jackson.core.JsonParser;
import com.fasterxml.jackson.databind.DeserializationContext;
import com.fasterxml.jackson.databind.JsonDeserializer;
import com.fasterxml.jackson.databind.JsonNode;

public class ArchiveMetadataDeserializer extends JsonDeserializer<ArchiveMetadata> {
  
    @Override
    public ArchiveMetadata deserialize(JsonParser jp, DeserializationContext ctxt) 
      throws IOException {
        JsonNode node = jp.getCodec().readTree(jp);
        ArchiveMetadata am = new ArchiveMetadata();
        am.setDlcmId(node.get("dlcmId").asText());
        am.setIndex(node.get("index").asText());
        am.setType(node.get("type").asText());
        if (node.has("metadata")){
        	am.setMetadata(node.findValue("metadata").toString());
        }
        return am;
    }
}