package ch.dlcm.model;

import java.util.ArrayList;
import java.util.List;

import ch.dlcm.rest.RESTName;

public enum DataCategory {
	Primary(null),
		Observational(DataCategory.Primary), 
		Experimental(DataCategory.Primary), 
		Simulation(DataCategory.Primary), 
		Derived(DataCategory.Primary), 
		Reference(DataCategory.Primary),
	Secondary(null), 
		Publication(DataCategory.Secondary),
		DataPaper(DataCategory.Secondary),
		Documentation(DataCategory.Secondary),
	Package(null),
		InformationPackage(DataCategory.Package), 
		Metadata(DataCategory.Package), 
		ExternalMetadata(DataCategory.Package),
	Software(null), 
		Code(DataCategory.Software),
		Binaries(DataCategory.Software),
		VirtualMachine(DataCategory.Software),
	Others(null),
		Unknown(DataCategory.Others),
		Miscellaneous(DataCategory.Others);
	
	private DataCategory category = null;

    private DataCategory(DataCategory parent) {
        this.category = parent;
    }

    public static List<DataCategory> listCategories(){
    	return listCategories(null);
    }
    
    public static List<DataCategory> listSubCategories(String category){
        if (category == null || ("").equals(category) || category.equals(RESTName.ALL)){
    		return listSubCategories();
    	}
    	return listCategories(DataCategory.valueOf(category));
    }
    
    public static List<DataCategory> listSubCategories(){
    	List<DataCategory> list = new ArrayList<>();
    	for(DataCategory dc : DataCategory.values()){
    		if (dc.category != null){
    			list.add(dc);
    		}
    	}
    	return list;

    }

    public static boolean check(DataCategory cat, DataCategory subcat){
    	if (listCategories().contains(cat)){
    		if (listCategories(cat).contains(subcat)){
    			return true;
    		}
    	}
    	return false;
    }

    public static List<DataCategory> listCategories(DataCategory parent){
    	List<DataCategory> list = new ArrayList<>();
    	for(DataCategory dc : DataCategory.values()){
    		if (dc.category == parent){
    			list.add(dc);
    		}
    	}
    	return list;
    }
}
