package ch.dlcm.model;

import java.util.List;

import ch.dlcm.model.Status.StatusValue;

public interface DataFileInterface {
	public String getPackageId();
	public String getDlcmId();
	public void setPackageId(String packageId);
	public DataFile getDataFile();
	public void setDataFile(DataFile dataFile);
	public <T extends DataFileChecksum>  List<T> getChecksum();
	public void updateTime();
	public default void setFileStatus(StatusValue status){
		this.getDataFile().getStatus().setValue(status);
		this.getDataFile().getStatus().setInfo(null);
		updateTime();
	}
	public default void setErrorStatus(String desc){
		this.getDataFile().getStatus().setValue(StatusValue.InError);
		this.getDataFile().getStatus().setInfo(desc);
		updateTime();
	}
	
	public default void check(){
		if (!DataCategory.check(this.getDataFile().getDataCategory(), this.getDataFile().getDataType())){
			throw new IllegalArgumentException("Wrong data category: "+this.getDataFile().getDataCategory()+"/"+this.getDataFile().getDataType());
		}
	}
}
