package ch.dlcm.model;

import ch.dlcm.rest.RESTCompositeResource;

import javax.persistence.Entity;
import javax.persistence.Transient;
import java.util.Objects;


@Entity
public class OrganizationalUnitPersonRole extends RESTCompositeResource<OrganizationalUnitPersonPkId> {

  public OrganizationalUnitPersonRole() {
    this.dlcmCompositeId = new OrganizationalUnitPersonPkId();
  }

  @Transient
  public Person getPerson() {
    return dlcmCompositeId.getPerson();
  }

  @Transient
  public void setPerson(Person person) {
    dlcmCompositeId.setPerson(person);
  }

  @Transient
  public OrganizationalUnit getOrganizationalUnit() {
    return dlcmCompositeId.getOrganizationalUnit();
  }

  @Transient
  public void setOrganizationalUnit(OrganizationalUnit organizationalUnit) {
    dlcmCompositeId.setOrganizationalUnit(organizationalUnit);
  }

  @Transient
  public Role getRole() {
    return dlcmCompositeId.getRole();
  }

  @Transient
  public void setRole(Role role) {
    dlcmCompositeId.setRole(role);
  }


  @Override
  public boolean equals(Object other) {
    if (other == null || !(other instanceof OrganizationalUnitPersonRole)) {
      return false;
    }
    OrganizationalUnitPersonRole castOther = (OrganizationalUnitPersonRole) other;
    return Objects.equals(getOrganizationalUnit(), castOther.getOrganizationalUnit()) && Objects.equals(getPerson(), castOther.getPerson())
            && Objects.equals(getRole(), castOther.getRole());
  }
}
