package ch.dlcm.model;

import java.util.ArrayList;
import java.util.List;

public enum QueryType {
  DIRECT("Direct"), SIMPLE("Simple"), ADVANCED("Advanced"), IMAGE("Image");
  private String label;

  private QueryType(String t) {
    label = t;
  }

  public String getLabel() {
    return label;
  }

  public boolean isDirect() {
    return this == DIRECT;
  }

  public boolean isSimple() {
    return this == SIMPLE;
  }

  public static List<String> getQueryType() {
    List<String> list = new ArrayList<>();
    list.add(DIRECT.getLabel());
    list.add(SIMPLE.getLabel());
    list.add(ADVANCED.getLabel());
    list.add(IMAGE.getLabel());
    return list;
  }
}
