package ch.dlcm.model.display;

import ch.dlcm.model.OrganizationalUnit;
import ch.dlcm.model.Person;
import ch.dlcm.model.Role;
import ch.dlcm.model.display.mapper.ResourceRoleMapper;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;

import java.util.ArrayList;
import java.util.List;

public class PersonRole extends Person implements RessourceRole {

  public PersonRole(Person person, OrganizationalUnit organizationalUnit) {
    ResourceRoleMapper<Person> resourceRoleMapper = new ResourceRoleMapper<>(this, person);
    resourceRoleMapper.doRoleFilter(person, organizationalUnit);
  }

  @JsonIgnoreProperties({"creationTime", "updateTime", "dlcmId"})
  private List<Role> roles = new ArrayList<>();

  public List<Role> getRoles() {
    return this.roles;
  }

  public void setRoles(List<Role> roles) {
    this.roles = roles;
  }
}
