package ch.dlcm.model.validator;

import javax.validation.Constraint;
import javax.validation.Payload;
import java.lang.annotation.Documented;
import java.lang.annotation.Retention;
import java.lang.annotation.Target;

import static java.lang.annotation.ElementType.ANNOTATION_TYPE;
import static java.lang.annotation.ElementType.FIELD;
import static java.lang.annotation.ElementType.TYPE;
import static java.lang.annotation.RetentionPolicy.RUNTIME;

@Target({TYPE, ANNOTATION_TYPE, FIELD})
@Retention(RUNTIME)
@Constraint(validatedBy = AssertThatAnotherFieldHasValueValidator.class)
@Documented
public @interface AssertThatAnotherFieldHasValue {

    String fieldName();
    String fieldValue();
    String dependFieldName();
    String message() default "{message.validator.assert.another.field.has.value}";
    Class<?>[] groups() default {};
    Class<? extends Payload>[] payload() default {};

    @Target({TYPE, ANNOTATION_TYPE, FIELD})
    @Retention(RUNTIME)
    @Documented
    @interface List {
        AssertThatAnotherFieldHasValue[] value();
    }
}
