package ch.dlcm.rest;

import java.util.Collections;
import java.util.List;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.hateoas.ResourceSupport;

public class RESTCollection<T> extends ResourceSupport {
	private Iterable<T> _data;
	private RESTPage _pageable;

	public RESTCollection() {
		this._data = Collections.emptyList();
		this._pageable = new RESTPage();
	}
	
	public RESTCollection(List<T> list) {
		this._data = list;
		this._pageable = new RESTPage(list.size());
	}
	
	public RESTCollection(List<T> list, RESTPage page) {
    this._data = list;
    this._pageable = page;
  }
	
	public RESTCollection(Page<T> page, Pageable pageable) {
		this._data = page.getContent();
		this._pageable = new RESTPage(page,pageable);
	}

	public Iterable<T> get_data() {
		return _data;
	}

	public RESTPage get_page() {
		return _pageable;
	}

}