package ch.dlcm.rest;

import ch.dlcm.model.Deposit;
import ch.dlcm.model.DepositDataFile;
import ch.dlcm.model.FundingAgency;
import ch.dlcm.model.Institution;
import ch.dlcm.model.Language;
import ch.dlcm.model.License;
import ch.dlcm.model.OrganizationalUnit;
import ch.dlcm.model.Person;
import ch.dlcm.model.Role;
import ch.dlcm.model.SubmissionAgreement;
import ch.dlcm.model.oais.AipDataFile;
import ch.dlcm.model.oais.ArchivalInfoPackage;
import ch.dlcm.model.oais.DipDataFile;
import ch.dlcm.model.oais.DisseminationInfoPackage;
import ch.dlcm.model.oais.SipDataFile;
import ch.dlcm.model.oais.SubmissionInfoPackage;

public class RESTName {
  // Modules
  public static final String ADMIN = "admin";
  public static final String PREINGEST = "preingest";
  public static final String INGEST = "ingest";
  public static final String ACCESS = "access";
  public static final String DATAMGMT = "data-mgmt";
  public static final String ARCHIVALSTORAGE = "archival-storage";

  // Resources
  public static final String DEPOSIT = "deposits";
  public static final String ORDER = "orders";
  public static final String PERSON = "people";
  public static final String UNIT = "projects";
  public static final String INSTITUTION = "institutions";
  public static final String DATAFILE = "data";
  public static final String SIP = "sip";
  public static final String AIP = "aip";
  public static final String DIP = "dip";
  public static final String DI = "di";
  public static final String SETTING = "settings";
  public static final String SUBMISSION_AGREEMENT = "submission-agreement";
  public static final String LICENSE = "licences";
  public static final String ROLE = "roles";
  public static final String FUNDING_AGENCY = "funding-agencies";

  // Miscellaneous
  public static final String ERROR = "error";
  public static final String DL = "download";
  public static final String UL = "upload";
  public static final String IMPORT = "import";
  public static final String IMPORTED = "imported";
  public static final String RESUME = "resume";
  public static final String REINDEX = "reindex";
  public static final String SUBMIT = "submit";
  public static final String VIEW = "view";
  public static final String VIEW_QUERY = "view-query";
  public static final String SAVE = "save";
  public static final String SEARCH = "search";
  public static final String HISTORY = "history";
  public static final String STATUS = "list-status";
  public static final String ACCESS_TYPES = "list-accesses";
  public static final String LANGUAGE = "languages";
  public static final String DATACATEGORY = "list-data-category";
  public static final String DATATYPE = "list-data-type";
  public static final String QUERYTYPE = "list-query-type";
  public static final String ALL = "All";

  // Parameter
  public static final String SIZE = "size";
  public static final String PAGE = "page";
  public static final String SORT = "sort";
  public static final String CREATION = "creationTime";
  public static final String UPDATE = "updateTime";

  public static String getRESTName(Class<?> restClass) {
    if (restClass.equals(Deposit.class)) {
      return DEPOSIT;
    }
    if (restClass.equals(DepositDataFile.class) ||
        restClass.equals(SipDataFile.class)||
        restClass.equals(AipDataFile.class)||
        restClass.equals(DipDataFile.class)) {
      return DATAFILE;
    }
    if (restClass.equals(Person.class)) {
      return PERSON;
    }
    if (restClass.equals(Institution.class)) {
      return INSTITUTION;
    }
    if (restClass.equals(SubmissionInfoPackage.class)) {
      return SIP;
    }
    if (restClass.equals(ArchivalInfoPackage.class)) {
      return AIP;
    }
    if (restClass.equals(DisseminationInfoPackage.class)) {
      return DIP;
    }
    if (restClass.equals(SubmissionAgreement.class)) {
      return SUBMISSION_AGREEMENT;
    }
    if (restClass.equals(License.class)) {
      return LICENSE;
    }
    if (restClass.equals(Language.class)) {
      return LANGUAGE;
    }
    if (restClass.equals(Role.class)) {
      return ROLE;
    }
    if (restClass.equals(OrganizationalUnit.class)) {
      return UNIT;
    }
    if (restClass.equals(FundingAgency.class)) {
      return FUNDING_AGENCY;
    }
    throw new IllegalArgumentException();
  }
}
