package ch.dlcm.rest;

import org.springframework.hateoas.ResourceSupport;

public class RESTResult extends ResourceSupport {

	private final String dlcmId;
	private ActionStatus status;
	private String message;

	public enum ActionStatus {
		Executed, NotExecuted, NonApplicable
	}
	
    public RESTResult(String id) {
    	this.dlcmId  = id;
    	this.status  = ActionStatus.NonApplicable;
    	this.message = null;
    }
    
    
	public String getDlcmId() {
		return dlcmId;
	}

	public ActionStatus getStatus() {
		return status;
	}

	public String getMessage() {
		return message;
	}

	public void setStatus(ActionStatus status) {
		this.status = status;
	}

	public void setMesssage(String m) {
		this.message = m;
	}
}
