package ch.dlcm.rest;

import org.springframework.hateoas.Link;
import org.springframework.web.util.UriComponentsBuilder;

public class RESTTool {

	public static Link parentLink(UriComponentsBuilder ucb) {
		String uri = ucb.toUriString();
		String parenturi = uri.substring(0, uri.lastIndexOf('/'));
		return new Link(parenturi);
	}

	public static Link sort(UriComponentsBuilder ucb, String criterion) {
		ucb.queryParam(RESTName.SORT, criterion+",desc");
		return new Link(ucb.toUriString());
	}
	
	public static Link pageLink(UriComponentsBuilder ucb, long size, long page) {
		ucb.queryParam(RESTName.SIZE, size);
		ucb.queryParam(RESTName.PAGE, page);
		return new Link(ucb.toUriString());
	}

	public static Link referenceLink(UriComponentsBuilder ucb, String module) {
		String uri = ucb.toUriString();
		String[] list = uri.split("/");
		list[list.length-5] = module;
		list[list.length-4] = list[list.length-2];
		list[list.length-3] = list[list.length-1];
		StringBuilder refUri = new StringBuilder(list[0]);
		for(int i=1;i<list.length-2;i++)
			refUri.append("/").append(list[i]);
		return new Link(refUri.toString());
	}
}
