package ch.dlcm.tool;

import java.time.OffsetDateTime;
import java.time.format.DateTimeFormatter;

import org.json.JSONObject;
import org.json.XML;

public class StringTool {
	public static final String DATE_FORMAT = "yyyy-MM-dd'T'HH:mm:ss.SSSZ";

	public static boolean toUpdate(String vOri, String vNew) {
		if (vNew == null || vNew.isEmpty())
			return false;
		if (vOri != null && vOri.equals(vNew))
			return false;
		return true;
	}
	
	public static String XML2JSON(String xmlString) {
		JSONObject json = XML.toJSONObject(xmlString);
		return json.toString();
	}
	
	public static String formatDate(OffsetDateTime date, DateTimeFormatter formatTemplate) {
		return date.toLocalDateTime().format(formatTemplate);
	}
	
	public static String formatSmartSize(long size) {
		String unit;
		double s;
		if (size < 1024) {
			s = (double) size;
			unit = "B";
		} else if (size < (1024 * 1024)) {
			s = (double) size / 1024;
			unit = "KB";
		} else if (size < (1024 * 1024 * 1024)) {
			s = (double) size / (1024 * 1024);
			unit = "MB";
		} else if (size < (1024 * 1024 * 1024 * 1024)) {
			s = (double) size / (1024 * 1024 * 1024);
			unit = "GB";
		} else {
			s = (double) size / (1024 * 1024 * 1024 * 1024);
			unit = "TB";
		}
		return String.format("%.1f %s", s, unit);
	}

}
