package ch.dlcm.test.doc.matcher.accession;

import ch.dlcm.test.executor.DLCMTestDocHelper;
import org.hamcrest.Matcher;

import java.util.HashMap;
import java.util.Map;

import static ch.dlcm.test.executor.DLCMTestDocHelper.endsWithList;
import static org.hamcrest.CoreMatchers.*;
import static org.hamcrest.Matchers.hasKey;
import static org.hamcrest.Matchers.hasSize;
import static org.hamcrest.collection.IsMapContaining.hasValue;

public class AccessionDocMatcher {


    public static Map<String, Matcher> getAccessionRootExpectedMatchers() {
        Map<String, Matcher> expectedMap = new HashMap<>();
        expectedMap.put("name", is(notNullValue()));
        expectedMap.put("name", is("DLCM Backend - Accession"));
        final int SIZE_LINKS = DLCMTestDocHelper.getAccessionRootLinksActions().size();
        expectedMap.put("$._links.*", hasSize(SIZE_LINKS));
        for (String endPoint : DLCMTestDocHelper.getAccessionRootLinksActions()) {
            expectedMap.put("$._links", hasKey(endPoint));
            expectedMap.put("$._links." + endPoint, hasKey("href"));
            expectedMap.put("$._links." + endPoint, hasValue(anyOf(endsWithList(DLCMTestDocHelper.getAccessionRootLinksActions()))));
        }
        return expectedMap;
    }

    public static Map<String, String> getAccessionRootMapLinksDescription() {
        Map<String, String> links = new HashMap<>();
        DLCMTestDocHelper.getAccessionRootLinksActions().forEach(
                action -> links.put(action,"<<" + action + ", Links>> to " + action +" resource")
        );
        return links;
    }
}
