package ch.dlcm.test.doc.matcher.administration;

import static ch.dlcm.test.executor.DLCMTestDocHelper.endsWithList;
import static org.hamcrest.CoreMatchers.anyOf;
import static org.hamcrest.CoreMatchers.is;
import static org.hamcrest.CoreMatchers.notNullValue;
import static org.hamcrest.Matchers.hasKey;
import static org.hamcrest.Matchers.hasSize;
import static org.hamcrest.collection.IsMapContaining.hasValue;

import java.util.HashMap;
import java.util.Map;

import org.hamcrest.Matcher;

import ch.dlcm.test.doc.matcher.DLCMDocumentation;
import ch.dlcm.test.executor.DLCMTestDocHelper;

public class AdministrationDocMatcher implements DLCMDocumentation {
	
	@Override
    public Map<String, Matcher> getExpectedMatchers() {
        return getAdministrationRootExpectedMatchers();
    }

    @Override
    public Map<String, String> getMapFieldsDescription() {
        throw new IllegalAccessError();
    }

    @Override
    public Map<String, String> getMapLinksDescription() {
        return getAdministrationRootMapLinksDescription();
    }

    public static Map<String,String> getAdministrationRootMapLinksDescription() {
        Map<String, String> links = new HashMap<>();
        DLCMTestDocHelper.getAdministrationRootActions().forEach(
                action -> links.put(action,"<<" + action + ", Links>> to " + action +" resource")
        );
        return links;
    }

    public static Map<String, Matcher> getAdministrationRootExpectedMatchers(){
        Map<String, Matcher> expectedMap = new HashMap<>();
        expectedMap.put("name", is(notNullValue()));
        expectedMap.put("name", is("DLCM Backend - Administration"));
        final int SIZE_LINKS = DLCMTestDocHelper.getAdministrationRootActions().size();
        expectedMap.put("$._links.*", hasSize(SIZE_LINKS));
        for (String endPoint : DLCMTestDocHelper.getAdministrationRootActions()) {
            expectedMap.put("$._links", hasKey(endPoint));
            expectedMap.put("$._links." + endPoint, hasKey("href"));
            expectedMap.put("$._links." + endPoint, hasValue(anyOf(endsWithList(DLCMTestDocHelper.getAdministrationRootActions()))));
        }
        return expectedMap;
    }


}
