package ch.dlcm.test.doc.matcher.storagion;

import ch.dlcm.test.doc.matcher.DLCMDocumentation;
import ch.dlcm.test.executor.DLCMTestDocHelper;
import org.hamcrest.Matcher;

import java.util.HashMap;
import java.util.Map;

import static ch.dlcm.test.executor.DLCMTestDocHelper.endsWithList;
import static org.hamcrest.CoreMatchers.*;
import static org.hamcrest.Matchers.hasKey;
import static org.hamcrest.Matchers.hasSize;
import static org.hamcrest.collection.IsMapContaining.hasValue;

public class DataMgmtDocMatcher implements DLCMDocumentation {
    @Override
    public Map<String, Matcher> getExpectedMatchers() {
        return getDataMgmtExpectedMatchers();
    }

    @Override
    public Map<String, String> getMapFieldsDescription() {
        return null;
    }

    @Override
    public Map<String, String> getMapLinksDescription() {
        return null;
    }

    public static Map<String, Matcher> getDataMgmtExpectedMatchers() {
        Map<String, Matcher> expectedMap = new HashMap<>();
        expectedMap.put("name", is(notNullValue()));
        expectedMap.put("name", is("data-mgmt"));
        final int SIZE_LINKS = DLCMTestDocHelper.getDataMgmtActions().size();
        expectedMap.put("$._links.*", hasSize(SIZE_LINKS));
        for (String endPoint : DLCMTestDocHelper.getDataMgmtActions()) {
            expectedMap.put("$._links", hasKey(endPoint));
            expectedMap.put("$._links." + endPoint, hasKey("href"));
            expectedMap.put("$._links." + endPoint, hasValue(anyOf(endsWithList(DLCMTestDocHelper.getDataMgmtLinksActions()))));
        }
        // _links.resources
        final int SIZE_RESSOURCES = DLCMTestDocHelper.getDataMgmtResourcesActions().size();
        expectedMap.put("$._links.resources", hasSize(SIZE_RESSOURCES));
        for (int i = 0; i < SIZE_RESSOURCES; i++) {
            expectedMap.put("$._links.resources["+ i +"]", hasKey("href"));
            expectedMap.put("$._links.resources["+ i +"]", hasValue(anyOf(endsWithList(DLCMTestDocHelper.getDataMgmtResourcesActions()))));
        }

        return expectedMap;

    }

}