package ch.dlcm.tools;

import java.nio.file.Path;

import org.apache.log4j.Logger;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.boot.CommandLineRunner;
import org.springframework.stereotype.Component;

@Component
public class SIPUploader extends Tools implements CommandLineRunner {
	private static final Logger log = Logger.getLogger(SIPUploader.class);

	@Value("${dlcm.import.sip}")
	private String importFolder;

	@Override
	public void run(String... arg0) throws Exception {
		if (!importFolder.isEmpty()) {
			log.info("Scanning folder: " + importFolder);
			int count = 0;
			for (Path d : scanAll(importFolder)) {
				count++;
				log.info("Importing " + d.toString());
				if (createSIP(d) == null) {
					log.error("Cannot import SIP " + d.toString());
				}
			}
			log.info("Importing end " + importFolder + ": " + count + " uploaded SIP file(s)");
		}
	}

}